#include <string.h>
#include <xmms/xmmsctrl.h>
#include <stdio.h>

#include "xmms_func.h"

unsigned int xmms_session = 0;

void XmmsPlay() {
	xmms_remote_play(xmms_session);
}

void XmmsStop() {
	xmms_remote_stop(xmms_session);
}

void XmmsPause() {
	xmms_remote_pause(xmms_session);
}

void XmmsEject() {
	xmms_remote_eject(xmms_session);
}

void XmmsPrev() {
	xmms_remote_playlist_prev(xmms_session);
}

void XmmsNext() {
	xmms_remote_playlist_next(xmms_session);
}

void XmmsFastr() {
	xmms_remote_jump_to_time(xmms_session,xmms_remote_get_output_time(xmms_session)-10000);
}

void XmmsFastf() {
	xmms_remote_jump_to_time(xmms_session,xmms_remote_get_output_time(xmms_session)+10000);
}

int XmmsGetVolume() {
	return xmms_remote_get_main_volume(xmms_session);
}

void XmmsToggleShuffle() {
	xmms_remote_toggle_shuffle(xmms_session);
}

void XmmsToggleRepeat() {
	xmms_remote_toggle_repeat(xmms_session);
}

int XmmsStatus() {
	return xmms_remote_is_running(xmms_session);
}

int XmmsPauseStatus() {
	return xmms_remote_is_paused(xmms_session);
}

int XmmsShuffleStatus() {
	return xmms_remote_is_shuffle(xmms_session);
}

int XmmsRepeatStatus() {
	return xmms_remote_is_repeat(xmms_session);
}

int XmmsPlayStatus() {
	return xmms_remote_is_playing(xmms_session);
}

int XmmsMainWinStatus() {
	return xmms_remote_is_main_win(xmms_session);
}

int XmmsPlaylistWinStatus() {
	return xmms_remote_is_pl_win(xmms_session);
}

int XmmsGetTrack() {
	return xmms_remote_get_playlist_pos(xmms_session);
}

char *XmmsGetTitle() {
	return xmms_remote_get_playlist_title(xmms_session,XmmsGetTrack());
}

int XmmsGetTotalTime(int trk) {
	return xmms_remote_get_playlist_time(xmms_session,trk);
}

int XmmsGetTime() {
	return xmms_remote_get_output_time(xmms_session);
}

void XmmsSetVolume(int v) {
	xmms_remote_set_main_volume(xmms_session,v);
}

void XmmsTogglePlaylistWin(int v) {
	xmms_remote_pl_win_toggle(xmms_session,v);
}

void XmmsToggleMainWin(int v) {
	xmms_remote_main_win_toggle(xmms_session,v);
}

void ExecuteXmms(void)
{
       char *command;
       int status;

       command=malloc(strlen(xmms_cmd)+5);
       sprintf(command, "%s &", xmms_cmd);
       status = system(command);
       if (status)
        {
      		fprintf(stderr, "XMMS can't be launched, exiting...");
      		exit(1);
        }
       while (!xmms_remote_is_running(xmms_session))
       		usleep(10000L);
       free(command);
}

